---
product: "AG Studio"
title: "Building Widgets"
description: "A Widget on the layout has its data and appearance configured in the Edit Panel."
framework: javascript
version: "3.0.0"
related:
    - title: "Widget Basics"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/javascript/widgets/"
    - title: "Widget Catalogue"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/javascript/widget-catalogue/"
llms: "https://www.ag-grid.com/studio/archive/3.0.0/llms.txt"
---

# Building Widgets

A Widget on the layout has its data and appearance configured in the Edit Panel.

In [Edit Mode](https://www.ag-grid.com/studio/archive/3.0.0/javascript/user-interface/#modes), clicking a Widget on the layout puts it into focus. When a Widget is focused, the [Edit Panel](https://www.ag-grid.com/studio/archive/3.0.0/javascript/user-interface/#edit-panel) updates to show Widget configuration, split into two tabs:

- **Setup** - configures data inputs and interactivity.
- **Format** - controls how the Widget looks.

The example below shows a bar chart displaying Net Sales by Region. Clicking on the chart updates the Edit Panel to show the Setup and Format tabs for that Widget.

#### Edit Panel

```ts
import {
  AgReportState,
  AgStudioApi,
  AgStudioProperties,
  createStudio,
  enableStudioDevValidations,
} from "ag-studio";
import { getMainDemoData } from "./data.ts";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const initialState: AgReportState = {
  pages: [
    {
      id: "a",
      widgets: {
        "region-net-sales": {
          type: "bar-chart-grouped",
          dataMapping: {
            categoryKey: [{ id: "stores.region" }],
            valueKey: [{ id: "net_sales" }],
          },
          format: {
            title: {
              enabled: true,
              text: "Net Sales by Region",
            },
          },
        },
      },
      widgetLayout: {
        "region-net-sales": { xTrack: 0, yTrack: 0, xSpan: 24, ySpan: 32 },
      },
    },
  ],
  selectedPageId: "a",
};

const studioProperties: AgStudioProperties = {
  mode: "edit",
  initialState,
  panels: {
    edit: {
      right: ["edit"],
    },
  },
  data: getMainDemoData("https://www.ag-grid.com/studio/archive/3.0.0/example-assets"),
};

let studioApi: AgStudioApi;

// setup Studio after the page has finished loading
const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
studioApi = createStudio(studioDiv, studioProperties);
```

[Live example: Edit Panel](https://www.ag-grid.com/studio/archive/3.0.0/examples/building-widgets/edit-panel-setup/typescript/)

## Widget Setup

Data can be dragged and dropped into an empty Widget or the Setup data section. The UI guides visually to the appropriate drop targets. If an item cannot be used in a slot, AG Studio prevents the drop and guides to a valid slot. This might be because no relationship between data is defined or Widget data requirements are not met.

Where possible, items can be reordered within a slot by dragging them into the required order, which determines the order of Fields being displayed. For detailed information on managing data fields, see [Data Setup](https://www.ag-grid.com/studio/archive/3.0.0/javascript/data-setup/).

To remove an item, its remove action can be used from the data menu accessible in the data pill. Aggregation and sorting options are also in the same menu. Read more on [Aggregation and Sorting](https://www.ag-grid.com/studio/archive/3.0.0/javascript/using-data/#aggregation).

Widgets can be changed to a different type via the Setup Panel dropdown. AG Studio will preserve field configurations during Widget type switching where possible. Where the new input requirement needs less data, additional fields will be dropped into Tooltip.

## Widget Formatting

Format settings vary by Widget type. Common settings include the Widget title and description, number formatting, labels and legends, and display options.

Additional customisation is supported on interactivity features such as crosshair, navigator, and zoom. The options available for customisation depend on the application preset and will vary depending on what is permitted.

## Reset to Default

When an Edit Panel setting differs from the default value, a reset to default button will appear next to the section name. Clicking this will reset all settings within that section to their default values.

Default values are different from saved state. If your application has loaded a saved state, the values will reset to the Studio default values rather than the saved state. The default values can be configured by your developer.

## Working with Date & Time

There are two ways to put dates on a Widget's axis, and they differ in the span of time the axis covers:

- **Drag a date field** - the axis covers the range of dates present in that field's data.
- **Drag a calendar** - the axis covers the date range defined for the calendar, regardless of which dates appear in the data.

In both cases the axis still narrows to match any filters applied to the Widget.

### Using a Date Field

Drop a date field onto a chart or table and the axis spans the dates found in that field. It groups by a default period - day for a date field, minute for a field that also carries a time of day.

To change the period, select the Widget to open the Setup panel on the right, then open the date field's menu from its pill in the data section and pick another period - year, quarter, month, week, or day. The periods on offer are configured by the developer. The pill shows the field name and the period it's using, for example Order Date · Month, so you can always see how dates are grouped. Changing the period re-groups the same field in place; you don't need to remove it and drag a different one.

In the example below, the Order Date field is on the axis and grouped by year. Select the chart, open the field's menu from its pill, and switch the period to see the chart re-group.

#### Grouping Dates on an Axis

```ts
import {
  AgReportState,
  AgStudioProperties,
  createStudio,
  enableStudioDevValidations,
} from "ag-studio";
import { getData } from "./data.ts";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const initialState: AgReportState = {
  selectedPageId: "by-year",
  pages: [
    {
      id: "by-year",
      selection: { type: "widget", id: "year-chart" },
      widgets: {
        "year-chart": {
          type: "bar-chart-grouped",
          dataMapping: {
            categoryKey: [{ id: "sales.order_date::year" }],
            valueKey: [{ id: "sales.amount", aggregation: "sum" }],
            tooltipKey: [],
          },
          format: { title: { enabled: true, text: "Revenue by Year" } },
        },
        "year-grid": {
          type: "grid",
          dataMapping: {
            cols: [
              { id: "sales.order_date::year" },
              { id: "sales.amount", aggregation: "sum" },
              { id: "sales.amount", aggregation: "count" },
              { id: "sales.amount", aggregation: "avg" },
            ],
          },
          sort: [{ field: { id: "sales.order_date::year" }, direction: "asc" }],
        },
      },
      widgetLayout: {
        "year-chart": { xTrack: 0, yTrack: 0, xSpan: 24, ySpan: 20 },
        "year-grid": { xTrack: 0, yTrack: 20, xSpan: 24, ySpan: 10 },
      },
    },
  ],
  panels: {
    filters: {
      collapsed: true,
    },
    data: {
      collapsed: true,
    },
  },
};

const studioProperties: AgStudioProperties = {
  data: getData(),
  mode: "edit",
  initialState,
};

const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
createStudio(studioDiv, studioProperties);
```

[Live example: Grouping Dates on an Axis](https://www.ag-grid.com/studio/archive/3.0.0/examples/building-widgets/time-axis-example/typescript/)

### Using a Calendar

A [calendar](https://www.ag-grid.com/studio/archive/3.0.0/javascript/calendars/) is a named date range defined in the dashboard's data, with a fixed start and end. Its time periods (Year, Quarter, Month, and so on) appear in the Data Panel as their own group, named after the calendar.

Dragging a calendar period works just like dragging a date field - you place it on an axis and change its period from the pill the same way. Two things differ: the periods on offer come from the calendar, and the axis spans the calendar's whole range rather than the dates in your data.

Drag a calendar period such as Month onto a Widget and a chart's timeline stays continuous: periods with no data show as gaps instead of being skipped, which keeps trends honest. The axis still responds to filters, narrowing to the filtered range.

The example below produces the same chart as above, but the axis comes from dragging in a calendar period rather than the date field. Select the chart and open the field's menu to switch the period.

#### Grouping Dates with a Calendar

```ts
import {
  AgReportState,
  AgStudioProperties,
  createStudio,
  enableStudioDevValidations,
} from "ag-studio";
import { getData } from "./data.ts";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const initialState: AgReportState = {
  selectedPageId: "by-year",
  pages: [
    {
      id: "by-year",
      selection: { type: "widget", id: "year-chart" },
      widgets: {
        "year-chart": {
          type: "bar-chart-grouped",
          dataMapping: {
            categoryKey: [{ id: "calendar::year" }],
            valueKey: [{ id: "sales.amount", aggregation: "sum" }],
            tooltipKey: [],
          },
          format: { title: { enabled: true, text: "Revenue by Year" } },
        },
        "year-grid": {
          type: "grid",
          dataMapping: {
            cols: [
              { id: "calendar::year" },
              { id: "sales.amount", aggregation: "sum" },
              { id: "sales.amount", aggregation: "count" },
              { id: "sales.amount", aggregation: "avg" },
            ],
          },
          sort: [{ field: { id: "calendar::year" }, direction: "asc" }],
        },
      },
      widgetLayout: {
        "year-chart": { xTrack: 0, yTrack: 0, xSpan: 24, ySpan: 20 },
        "year-grid": { xTrack: 0, yTrack: 20, xSpan: 24, ySpan: 10 },
      },
    },
  ],
  panels: {
    filters: {
      collapsed: true,
    },
    data: {
      collapsed: true,
    },
  },
};

const studioProperties: AgStudioProperties = {
  data: getData(),
  mode: "edit",
  initialState,
};

const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
createStudio(studioDiv, studioProperties);
```

[Live example: Grouping Dates with a Calendar](https://www.ag-grid.com/studio/archive/3.0.0/examples/building-widgets/time-axis-calendar-example/typescript/)

## Group By Legend

The Legend field splits a single chart into multiple coloured series by a categorical dimension - for example, sales broken down by region. It is available on Bar, Column, Line, Area, Scatter, and Bubble charts.

Charts that support a legend expose a **Legend** slot in the Setup panel. Assign a categorical field to break the chart down by that field's distinct values: each value gets its own colour, and the legend updates automatically. Removing the field reverts to a single series.

### Bar and Column Charts

How a Legend field segments each bar or column depends on how many measures are present.

**Single measure.** The Legend field splits each bar or column by the field's distinct values, arranged according to the chart variant:

- **Clustered** - values appear as separate bars side by side within each category.
- **Stacked** - values appear as stacked segments within one bar.
- **100% Stacked** - segments are proportional, each bar normalised to 100%.

**Multiple measures, no Legend field.** Each measure becomes its own series, defined by the measure name.

**Multiple measures with a Legend field.** Measures form the primary (outer) grouping and legend values the secondary (inner) grouping. Colours stay consistent per legend value across every measure group. For example, plot Net Sales and Gross Sales by region with Segment in the Legend slot - X-Axis: Region, Y-Axis: Net Sales and Gross Sales, Legend: Segment. Each region then carries six values - Net Sales and Gross Sales, each split across Enterprise, Mid-Market, and SMB - arranged according to the chart variant:

- **Clustered** - six bars per region, grouped by measure first (the three Net Sales bars, then the three Gross Sales bars).
- **Stacked** - two bars per region (Net Sales, Gross Sales), each split into Enterprise, Mid-Market, and SMB segments.
- **100% Stacked** - as Stacked, normalised to 100%.

The example below plots Net Sales and Gross Sales by region with **Segment** assigned to the Legend slot, so each measure splits into one coloured series per segment - Enterprise, Mid-Market, and SMB - with colours consistent across both measures. Open the Setup panel to change or clear the Legend field, or change the chart type to another bar or column variant to see how the arrangement differs.

#### Legend on Bar and Column Charts

```ts
import {
  AgReportState,
  AgStudioApi,
  AgStudioProperties,
  createStudio,
  enableStudioDevValidations,
} from "ag-studio";
import { getMainDemoData } from "./data.ts";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const initialState: AgReportState = {
  pages: [
    {
      id: "a",
      widgets: {
        "region-net-sales": {
          type: "bar-chart-stacked",
          dataMapping: {
            categoryKey: [{ id: "stores.region" }],
            valueKey: [{ id: "net_sales" }, { id: "gross_sales" }],
            legendKey: [{ id: "customers.segment" }],
          },
          format: {
            title: {
              enabled: true,
              text: "Net Sales and Gross Sales by Region and Segment",
            },
            style: {
              theme: {
                common: {
                  legend: {
                    enabled: true,
                  },
                },
              },
            },
          },
        },
      },
      widgetLayout: {
        "region-net-sales": { xTrack: 0, yTrack: 0, xSpan: 24, ySpan: 32 },
      },
      selection: { type: "widget", id: "region-net-sales" },
    },
  ],
  selectedPageId: "a",
};

const studioProperties: AgStudioProperties = {
  mode: "edit",
  initialState,
  panels: {
    edit: {
      right: ["edit"],
    },
  },
  data: getMainDemoData("https://www.ag-grid.com/studio/archive/3.0.0/example-assets"),
};

let studioApi: AgStudioApi;

// setup Studio after the page has finished loading
const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
studioApi = createStudio(studioDiv, studioProperties);
```

[Live example: Legend on Bar and Column Charts](https://www.ag-grid.com/studio/archive/3.0.0/examples/building-widgets/legend-bar-column/typescript/)

### Scatter and Bubble Charts

The Legend field splits plotted points into one coloured series per distinct value, with consistent colours and tooltips reflecting the hovered point's legend value. Bubble charts behave identically: the Size measure still drives bubble area within each series.

The example below plots average quantity against average discount as a bubble chart, with bubble size driven by net sales and **Category** assigned to the Legend slot, so each point belongs to one coloured series per product category.

#### Legend on Scatter and Bubble Charts

```ts
import {
  AgReportState,
  AgStudioApi,
  AgStudioProperties,
  createStudio,
  enableStudioDevValidations,
} from "ag-studio";
import { getMainDemoData } from "./data.ts";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const initialState: AgReportState = {
  pages: [
    {
      id: "a",
      widgets: {
        "qty-vs-discount": {
          type: "bubble-chart",
          dataMapping: {
            groupByKey: [{ id: "products.brand" }],
            categoryKey: [{ id: "order_items.quantity", aggregation: "avg" }],
            valueKey: [{ id: "order_items.discount_pct", aggregation: "avg" }],
            sizeKey: [{ id: "line_net", aggregation: "sum" }],
            legendKey: [{ id: "products.subcategory" }],
          },
          format: {
            title: {
              enabled: true,
              text: "Quantity vs Discount (size by Net Sales)",
            },
            style: {
              theme: {
                common: { legend: { enabled: true, position: "bottom" } },
              },
            },
          },
        },
      },
      widgetLayout: {
        "qty-vs-discount": { xTrack: 0, yTrack: 0, xSpan: 24, ySpan: 38 },
      },
      selection: { type: "widget", id: "qty-vs-discount" },
    },
  ],
  selectedPageId: "a",
};

const studioProperties: AgStudioProperties = {
  mode: "edit",
  initialState,
  panels: {
    edit: {
      right: ["edit"],
    },
  },
  data: getMainDemoData("https://www.ag-grid.com/studio/archive/3.0.0/example-assets"),
};

let studioApi: AgStudioApi;

// setup Studio after the page has finished loading
const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
studioApi = createStudio(studioDiv, studioProperties);
```

[Live example: Legend on Scatter and Bubble Charts](https://www.ag-grid.com/studio/archive/3.0.0/examples/building-widgets/legend-scatter-bubble/typescript/)

### Line and Area Charts

**Single measure.** The Legend field splits the measure into one line or area per distinct value, each with its own colour and legend entry. This is the way to plot one measure across several categories - for example, revenue over time with one line per country.

**Multiple measures with a Legend field.** Each measure is split by every legend value, and the series are labelled with both parts, such as `Net Sales · Enterprise`. Colours stay consistent per series, and tooltips show the hovered series' legend value.

The Area variants stack the split series: **Stacked** areas add up to the total, and **100% Stacked** areas are normalised so each period fills the plot.

### Limiting the Number of Series

A Legend field with many distinct values would produce one series per value and a legend too large to read. Charts guard against this automatically, keeping only the most significant series. This engages only when the series count would exceed 50; below that, every series renders as normal.

Legend values are ranked by measure value, largest first, and the chart keeps the largest 50 series and leaves the rest out altogether. With several measures, every legend value produces one series per measure, so the measures share the limit: two measures keep the 25 largest legend values each, ranked by the first measure, and every measure shows the same values. Whenever series have been left out, the chart says so in the browser console while development validations are enabled.

## Widget-Specific Options

Some Widget families have setup slots and options of their own, such as the Rows, Columns and Values slots on a Pivot Table or the Hierarchy Levels on a Treemap. These are described with the Widget in the [Widget Catalogue](https://www.ag-grid.com/studio/archive/3.0.0/javascript/widget-catalogue/).


---
product: "AG Studio"
title: "Building Widgets"
description: "A Widget on the layout has its data and appearance configured in the Edit Panel."
framework: react
version: "3.0.0"
related:
    - title: "Widget Basics"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/react/widgets/"
    - title: "Widget Catalogue"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/react/widget-catalogue/"
llms: "https://www.ag-grid.com/studio/archive/3.0.0/llms.txt"
---

# Building Widgets

A Widget on the layout has its data and appearance configured in the Edit Panel.

In [Edit Mode](https://www.ag-grid.com/studio/archive/3.0.0/react/user-interface/#modes), clicking a Widget on the layout puts it into focus. When a Widget is focused, the [Edit Panel](https://www.ag-grid.com/studio/archive/3.0.0/react/user-interface/#edit-panel) updates to show Widget configuration, split into two tabs:

- **Setup** - configures data inputs and interactivity.
- **Format** - controls how the Widget looks.

The example below shows a bar chart displaying Net Sales by Region. Clicking on the chart updates the Edit Panel to show the Setup and Format tabs for that Widget.

#### Edit Panel

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgStudio, AgStudioRef } from "ag-studio-react";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgPanelConfig,
  AgReportState,
  AgStudioApi,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";
import { getMainDemoData } from "./data.tsx";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const StudioExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const studioStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [data, setData] = useState<AgDataSource>(
    getMainDemoData("https://www.ag-grid.com/studio/archive/3.0.0/example-assets"),
  );
  const initialState = useMemo<AgReportState>(() => {
    return {
      pages: [
        {
          id: "a",
          widgets: {
            "region-net-sales": {
              type: "bar-chart-grouped",
              dataMapping: {
                categoryKey: [{ id: "stores.region" }],
                valueKey: [{ id: "net_sales" }],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Net Sales by Region",
                },
              },
            },
          },
          widgetLayout: {
            "region-net-sales": { xTrack: 0, yTrack: 0, xSpan: 24, ySpan: 32 },
          },
        },
      ],
      selectedPageId: "a",
    };
  }, []);
  const panels = useMemo<AgPanelConfig>(() => {
    return {
      edit: {
        right: ["edit"],
      },
    };
  }, []);

  return (
    <div style={containerStyle}>
      <div style={{ display: "flex", flexDirection: "column", height: "100%" }}>
        <AgStudio
          style={studioStyle}
          className="my-studio-container"
          data={data}
          initialState={initialState}
          mode={"edit"}
          panels={panels}
        />
      </div>
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <StudioExample />
  </StrictMode>,
);
```

[Live example: Edit Panel](https://www.ag-grid.com/studio/archive/3.0.0/examples/building-widgets/edit-panel-setup/reactFunctionalTs/)

## Widget Setup

Data can be dragged and dropped into an empty Widget or the Setup data section. The UI guides visually to the appropriate drop targets. If an item cannot be used in a slot, AG Studio prevents the drop and guides to a valid slot. This might be because no relationship between data is defined or Widget data requirements are not met.

Where possible, items can be reordered within a slot by dragging them into the required order, which determines the order of Fields being displayed. For detailed information on managing data fields, see [Data Setup](https://www.ag-grid.com/studio/archive/3.0.0/react/data-setup/).

To remove an item, its remove action can be used from the data menu accessible in the data pill. Aggregation and sorting options are also in the same menu. Read more on [Aggregation and Sorting](https://www.ag-grid.com/studio/archive/3.0.0/react/using-data/#aggregation).

Widgets can be changed to a different type via the Setup Panel dropdown. AG Studio will preserve field configurations during Widget type switching where possible. Where the new input requirement needs less data, additional fields will be dropped into Tooltip.

## Widget Formatting

Format settings vary by Widget type. Common settings include the Widget title and description, number formatting, labels and legends, and display options.

Additional customisation is supported on interactivity features such as crosshair, navigator, and zoom. The options available for customisation depend on the application preset and will vary depending on what is permitted.

## Reset to Default

When an Edit Panel setting differs from the default value, a reset to default button will appear next to the section name. Clicking this will reset all settings within that section to their default values.

Default values are different from saved state. If your application has loaded a saved state, the values will reset to the Studio default values rather than the saved state. The default values can be configured by your developer.

## Working with Date & Time

There are two ways to put dates on a Widget's axis, and they differ in the span of time the axis covers:

- **Drag a date field** - the axis covers the range of dates present in that field's data.
- **Drag a calendar** - the axis covers the date range defined for the calendar, regardless of which dates appear in the data.

In both cases the axis still narrows to match any filters applied to the Widget.

### Using a Date Field

Drop a date field onto a chart or table and the axis spans the dates found in that field. It groups by a default period - day for a date field, minute for a field that also carries a time of day.

To change the period, select the Widget to open the Setup panel on the right, then open the date field's menu from its pill in the data section and pick another period - year, quarter, month, week, or day. The periods on offer are configured by the developer. The pill shows the field name and the period it's using, for example Order Date · Month, so you can always see how dates are grouped. Changing the period re-groups the same field in place; you don't need to remove it and drag a different one.

In the example below, the Order Date field is on the axis and grouped by year. Select the chart, open the field's menu from its pill, and switch the period to see the chart re-group.

#### Grouping Dates on an Axis

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgStudio, AgStudioRef } from "ag-studio-react";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgReportState,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";
import { getData } from "./data.tsx";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const StudioExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const studioStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [data, setData] = useState<AgDataSource>(getData());
  const initialState = useMemo<AgReportState>(() => {
    return {
      selectedPageId: "by-year",
      pages: [
        {
          id: "by-year",
          selection: { type: "widget", id: "year-chart" },
          widgets: {
            "year-chart": {
              type: "bar-chart-grouped",
              dataMapping: {
                categoryKey: [{ id: "sales.order_date::year" }],
                valueKey: [{ id: "sales.amount", aggregation: "sum" }],
                tooltipKey: [],
              },
              format: { title: { enabled: true, text: "Revenue by Year" } },
            },
            "year-grid": {
              type: "grid",
              dataMapping: {
                cols: [
                  { id: "sales.order_date::year" },
                  { id: "sales.amount", aggregation: "sum" },
                  { id: "sales.amount", aggregation: "count" },
                  { id: "sales.amount", aggregation: "avg" },
                ],
              },
              sort: [
                { field: { id: "sales.order_date::year" }, direction: "asc" },
              ],
            },
          },
          widgetLayout: {
            "year-chart": { xTrack: 0, yTrack: 0, xSpan: 24, ySpan: 20 },
            "year-grid": { xTrack: 0, yTrack: 20, xSpan: 24, ySpan: 10 },
          },
        },
      ],
      panels: {
        filters: {
          collapsed: true,
        },
        data: {
          collapsed: true,
        },
      },
    };
  }, []);

  return (
    <div style={containerStyle}>
      <div style={{ display: "flex", flexDirection: "column", height: "100%" }}>
        <AgStudio
          style={studioStyle}
          className="my-studio-container"
          data={data}
          initialState={initialState}
          mode={"edit"}
        />
      </div>
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <StudioExample />
  </StrictMode>,
);
```

[Live example: Grouping Dates on an Axis](https://www.ag-grid.com/studio/archive/3.0.0/examples/building-widgets/time-axis-example/reactFunctionalTs/)

### Using a Calendar

A [calendar](https://www.ag-grid.com/studio/archive/3.0.0/react/calendars/) is a named date range defined in the dashboard's data, with a fixed start and end. Its time periods (Year, Quarter, Month, and so on) appear in the Data Panel as their own group, named after the calendar.

Dragging a calendar period works just like dragging a date field - you place it on an axis and change its period from the pill the same way. Two things differ: the periods on offer come from the calendar, and the axis spans the calendar's whole range rather than the dates in your data.

Drag a calendar period such as Month onto a Widget and a chart's timeline stays continuous: periods with no data show as gaps instead of being skipped, which keeps trends honest. The axis still responds to filters, narrowing to the filtered range.

The example below produces the same chart as above, but the axis comes from dragging in a calendar period rather than the date field. Select the chart and open the field's menu to switch the period.

#### Grouping Dates with a Calendar

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgStudio, AgStudioRef } from "ag-studio-react";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgReportState,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";
import { getData } from "./data.tsx";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const StudioExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const studioStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [data, setData] = useState<AgDataSource>(getData());
  const initialState = useMemo<AgReportState>(() => {
    return {
      selectedPageId: "by-year",
      pages: [
        {
          id: "by-year",
          selection: { type: "widget", id: "year-chart" },
          widgets: {
            "year-chart": {
              type: "bar-chart-grouped",
              dataMapping: {
                categoryKey: [{ id: "calendar::year" }],
                valueKey: [{ id: "sales.amount", aggregation: "sum" }],
                tooltipKey: [],
              },
              format: { title: { enabled: true, text: "Revenue by Year" } },
            },
            "year-grid": {
              type: "grid",
              dataMapping: {
                cols: [
                  { id: "calendar::year" },
                  { id: "sales.amount", aggregation: "sum" },
                  { id: "sales.amount", aggregation: "count" },
                  { id: "sales.amount", aggregation: "avg" },
                ],
              },
              sort: [{ field: { id: "calendar::year" }, direction: "asc" }],
            },
          },
          widgetLayout: {
            "year-chart": { xTrack: 0, yTrack: 0, xSpan: 24, ySpan: 20 },
            "year-grid": { xTrack: 0, yTrack: 20, xSpan: 24, ySpan: 10 },
          },
        },
      ],
      panels: {
        filters: {
          collapsed: true,
        },
        data: {
          collapsed: true,
        },
      },
    };
  }, []);

  return (
    <div style={containerStyle}>
      <div style={{ display: "flex", flexDirection: "column", height: "100%" }}>
        <AgStudio
          style={studioStyle}
          className="my-studio-container"
          data={data}
          initialState={initialState}
          mode={"edit"}
        />
      </div>
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <StudioExample />
  </StrictMode>,
);
```

[Live example: Grouping Dates with a Calendar](https://www.ag-grid.com/studio/archive/3.0.0/examples/building-widgets/time-axis-calendar-example/reactFunctionalTs/)

## Group By Legend

The Legend field splits a single chart into multiple coloured series by a categorical dimension - for example, sales broken down by region. It is available on Bar, Column, Line, Area, Scatter, and Bubble charts.

Charts that support a legend expose a **Legend** slot in the Setup panel. Assign a categorical field to break the chart down by that field's distinct values: each value gets its own colour, and the legend updates automatically. Removing the field reverts to a single series.

### Bar and Column Charts

How a Legend field segments each bar or column depends on how many measures are present.

**Single measure.** The Legend field splits each bar or column by the field's distinct values, arranged according to the chart variant:

- **Clustered** - values appear as separate bars side by side within each category.
- **Stacked** - values appear as stacked segments within one bar.
- **100% Stacked** - segments are proportional, each bar normalised to 100%.

**Multiple measures, no Legend field.** Each measure becomes its own series, defined by the measure name.

**Multiple measures with a Legend field.** Measures form the primary (outer) grouping and legend values the secondary (inner) grouping. Colours stay consistent per legend value across every measure group. For example, plot Net Sales and Gross Sales by region with Segment in the Legend slot - X-Axis: Region, Y-Axis: Net Sales and Gross Sales, Legend: Segment. Each region then carries six values - Net Sales and Gross Sales, each split across Enterprise, Mid-Market, and SMB - arranged according to the chart variant:

- **Clustered** - six bars per region, grouped by measure first (the three Net Sales bars, then the three Gross Sales bars).
- **Stacked** - two bars per region (Net Sales, Gross Sales), each split into Enterprise, Mid-Market, and SMB segments.
- **100% Stacked** - as Stacked, normalised to 100%.

The example below plots Net Sales and Gross Sales by region with **Segment** assigned to the Legend slot, so each measure splits into one coloured series per segment - Enterprise, Mid-Market, and SMB - with colours consistent across both measures. Open the Setup panel to change or clear the Legend field, or change the chart type to another bar or column variant to see how the arrangement differs.

#### Legend on Bar and Column Charts

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgStudio, AgStudioRef } from "ag-studio-react";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgPanelConfig,
  AgReportState,
  AgStudioApi,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";
import { getMainDemoData } from "./data.tsx";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const StudioExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const studioStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [data, setData] = useState<AgDataSource>(
    getMainDemoData("https://www.ag-grid.com/studio/archive/3.0.0/example-assets"),
  );
  const initialState = useMemo<AgReportState>(() => {
    return {
      pages: [
        {
          id: "a",
          widgets: {
            "region-net-sales": {
              type: "bar-chart-stacked",
              dataMapping: {
                categoryKey: [{ id: "stores.region" }],
                valueKey: [{ id: "net_sales" }, { id: "gross_sales" }],
                legendKey: [{ id: "customers.segment" }],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Net Sales and Gross Sales by Region and Segment",
                },
                style: {
                  theme: {
                    common: {
                      legend: {
                        enabled: true,
                      },
                    },
                  },
                },
              },
            },
          },
          widgetLayout: {
            "region-net-sales": { xTrack: 0, yTrack: 0, xSpan: 24, ySpan: 32 },
          },
          selection: { type: "widget", id: "region-net-sales" },
        },
      ],
      selectedPageId: "a",
    };
  }, []);
  const panels = useMemo<AgPanelConfig>(() => {
    return {
      edit: {
        right: ["edit"],
      },
    };
  }, []);

  return (
    <div style={containerStyle}>
      <div style={{ display: "flex", flexDirection: "column", height: "100%" }}>
        <AgStudio
          style={studioStyle}
          className="my-studio-container"
          data={data}
          initialState={initialState}
          mode={"edit"}
          panels={panels}
        />
      </div>
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <StudioExample />
  </StrictMode>,
);
```

[Live example: Legend on Bar and Column Charts](https://www.ag-grid.com/studio/archive/3.0.0/examples/building-widgets/legend-bar-column/reactFunctionalTs/)

### Scatter and Bubble Charts

The Legend field splits plotted points into one coloured series per distinct value, with consistent colours and tooltips reflecting the hovered point's legend value. Bubble charts behave identically: the Size measure still drives bubble area within each series.

The example below plots average quantity against average discount as a bubble chart, with bubble size driven by net sales and **Category** assigned to the Legend slot, so each point belongs to one coloured series per product category.

#### Legend on Scatter and Bubble Charts

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgStudio, AgStudioRef } from "ag-studio-react";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgPanelConfig,
  AgReportState,
  AgStudioApi,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";
import { getMainDemoData } from "./data.tsx";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const StudioExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const studioStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [data, setData] = useState<AgDataSource>(
    getMainDemoData("https://www.ag-grid.com/studio/archive/3.0.0/example-assets"),
  );
  const initialState = useMemo<AgReportState>(() => {
    return {
      pages: [
        {
          id: "a",
          widgets: {
            "qty-vs-discount": {
              type: "bubble-chart",
              dataMapping: {
                groupByKey: [{ id: "products.brand" }],
                categoryKey: [
                  { id: "order_items.quantity", aggregation: "avg" },
                ],
                valueKey: [
                  { id: "order_items.discount_pct", aggregation: "avg" },
                ],
                sizeKey: [{ id: "line_net", aggregation: "sum" }],
                legendKey: [{ id: "products.subcategory" }],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Quantity vs Discount (size by Net Sales)",
                },
                style: {
                  theme: {
                    common: { legend: { enabled: true, position: "bottom" } },
                  },
                },
              },
            },
          },
          widgetLayout: {
            "qty-vs-discount": { xTrack: 0, yTrack: 0, xSpan: 24, ySpan: 38 },
          },
          selection: { type: "widget", id: "qty-vs-discount" },
        },
      ],
      selectedPageId: "a",
    };
  }, []);
  const panels = useMemo<AgPanelConfig>(() => {
    return {
      edit: {
        right: ["edit"],
      },
    };
  }, []);

  return (
    <div style={containerStyle}>
      <div style={{ display: "flex", flexDirection: "column", height: "100%" }}>
        <AgStudio
          style={studioStyle}
          className="my-studio-container"
          data={data}
          initialState={initialState}
          mode={"edit"}
          panels={panels}
        />
      </div>
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <StudioExample />
  </StrictMode>,
);
```

[Live example: Legend on Scatter and Bubble Charts](https://www.ag-grid.com/studio/archive/3.0.0/examples/building-widgets/legend-scatter-bubble/reactFunctionalTs/)

### Line and Area Charts

**Single measure.** The Legend field splits the measure into one line or area per distinct value, each with its own colour and legend entry. This is the way to plot one measure across several categories - for example, revenue over time with one line per country.

**Multiple measures with a Legend field.** Each measure is split by every legend value, and the series are labelled with both parts, such as `Net Sales · Enterprise`. Colours stay consistent per series, and tooltips show the hovered series' legend value.

The Area variants stack the split series: **Stacked** areas add up to the total, and **100% Stacked** areas are normalised so each period fills the plot.

### Limiting the Number of Series

A Legend field with many distinct values would produce one series per value and a legend too large to read. Charts guard against this automatically, keeping only the most significant series. This engages only when the series count would exceed 50; below that, every series renders as normal.

Legend values are ranked by measure value, largest first, and the chart keeps the largest 50 series and leaves the rest out altogether. With several measures, every legend value produces one series per measure, so the measures share the limit: two measures keep the 25 largest legend values each, ranked by the first measure, and every measure shows the same values. Whenever series have been left out, the chart says so in the browser console while development validations are enabled.

## Widget-Specific Options

Some Widget families have setup slots and options of their own, such as the Rows, Columns and Values slots on a Pivot Table or the Hierarchy Levels on a Treemap. These are described with the Widget in the [Widget Catalogue](https://www.ag-grid.com/studio/archive/3.0.0/react/widget-catalogue/).


---
product: "AG Studio"
title: "Building Widgets"
description: "A Widget on the layout has its data and appearance configured in the Edit Panel."
framework: angular
version: "3.0.0"
related:
    - title: "Widget Basics"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/angular/widgets/"
    - title: "Widget Catalogue"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/angular/widget-catalogue/"
llms: "https://www.ag-grid.com/studio/archive/3.0.0/llms.txt"
---

# Building Widgets

A Widget on the layout has its data and appearance configured in the Edit Panel.

In [Edit Mode](https://www.ag-grid.com/studio/archive/3.0.0/angular/user-interface/#modes), clicking a Widget on the layout puts it into focus. When a Widget is focused, the [Edit Panel](https://www.ag-grid.com/studio/archive/3.0.0/angular/user-interface/#edit-panel) updates to show Widget configuration, split into two tabs:

- **Setup** - configures data inputs and interactivity.
- **Format** - controls how the Widget looks.

The example below shows a bar chart displaying Net Sales by Region. Clicking on the chart updates the Edit Panel to show the Setup and Format tabs for that Widget.

#### Edit Panel

```ts
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component.ts';

const app = bootstrapApplication(AppComponent, {
    providers: [provideHttpClient()],
});
```

[Live example: Edit Panel](https://www.ag-grid.com/studio/archive/3.0.0/examples/building-widgets/edit-panel-setup/angular/)

## Widget Setup

Data can be dragged and dropped into an empty Widget or the Setup data section. The UI guides visually to the appropriate drop targets. If an item cannot be used in a slot, AG Studio prevents the drop and guides to a valid slot. This might be because no relationship between data is defined or Widget data requirements are not met.

Where possible, items can be reordered within a slot by dragging them into the required order, which determines the order of Fields being displayed. For detailed information on managing data fields, see [Data Setup](https://www.ag-grid.com/studio/archive/3.0.0/angular/data-setup/).

To remove an item, its remove action can be used from the data menu accessible in the data pill. Aggregation and sorting options are also in the same menu. Read more on [Aggregation and Sorting](https://www.ag-grid.com/studio/archive/3.0.0/angular/using-data/#aggregation).

Widgets can be changed to a different type via the Setup Panel dropdown. AG Studio will preserve field configurations during Widget type switching where possible. Where the new input requirement needs less data, additional fields will be dropped into Tooltip.

## Widget Formatting

Format settings vary by Widget type. Common settings include the Widget title and description, number formatting, labels and legends, and display options.

Additional customisation is supported on interactivity features such as crosshair, navigator, and zoom. The options available for customisation depend on the application preset and will vary depending on what is permitted.

## Reset to Default

When an Edit Panel setting differs from the default value, a reset to default button will appear next to the section name. Clicking this will reset all settings within that section to their default values.

Default values are different from saved state. If your application has loaded a saved state, the values will reset to the Studio default values rather than the saved state. The default values can be configured by your developer.

## Working with Date & Time

There are two ways to put dates on a Widget's axis, and they differ in the span of time the axis covers:

- **Drag a date field** - the axis covers the range of dates present in that field's data.
- **Drag a calendar** - the axis covers the date range defined for the calendar, regardless of which dates appear in the data.

In both cases the axis still narrows to match any filters applied to the Widget.

### Using a Date Field

Drop a date field onto a chart or table and the axis spans the dates found in that field. It groups by a default period - day for a date field, minute for a field that also carries a time of day.

To change the period, select the Widget to open the Setup panel on the right, then open the date field's menu from its pill in the data section and pick another period - year, quarter, month, week, or day. The periods on offer are configured by the developer. The pill shows the field name and the period it's using, for example Order Date · Month, so you can always see how dates are grouped. Changing the period re-groups the same field in place; you don't need to remove it and drag a different one.

In the example below, the Order Date field is on the axis and grouped by year. Select the chart, open the field's menu from its pill, and switch the period to see the chart re-group.

#### Grouping Dates on an Axis

```ts
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component.ts';

const app = bootstrapApplication(AppComponent, {
    providers: [provideHttpClient()],
});
```

[Live example: Grouping Dates on an Axis](https://www.ag-grid.com/studio/archive/3.0.0/examples/building-widgets/time-axis-example/angular/)

### Using a Calendar

A [calendar](https://www.ag-grid.com/studio/archive/3.0.0/angular/calendars/) is a named date range defined in the dashboard's data, with a fixed start and end. Its time periods (Year, Quarter, Month, and so on) appear in the Data Panel as their own group, named after the calendar.

Dragging a calendar period works just like dragging a date field - you place it on an axis and change its period from the pill the same way. Two things differ: the periods on offer come from the calendar, and the axis spans the calendar's whole range rather than the dates in your data.

Drag a calendar period such as Month onto a Widget and a chart's timeline stays continuous: periods with no data show as gaps instead of being skipped, which keeps trends honest. The axis still responds to filters, narrowing to the filtered range.

The example below produces the same chart as above, but the axis comes from dragging in a calendar period rather than the date field. Select the chart and open the field's menu to switch the period.

#### Grouping Dates with a Calendar

```ts
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component.ts';

const app = bootstrapApplication(AppComponent, {
    providers: [provideHttpClient()],
});
```

[Live example: Grouping Dates with a Calendar](https://www.ag-grid.com/studio/archive/3.0.0/examples/building-widgets/time-axis-calendar-example/angular/)

## Group By Legend

The Legend field splits a single chart into multiple coloured series by a categorical dimension - for example, sales broken down by region. It is available on Bar, Column, Line, Area, Scatter, and Bubble charts.

Charts that support a legend expose a **Legend** slot in the Setup panel. Assign a categorical field to break the chart down by that field's distinct values: each value gets its own colour, and the legend updates automatically. Removing the field reverts to a single series.

### Bar and Column Charts

How a Legend field segments each bar or column depends on how many measures are present.

**Single measure.** The Legend field splits each bar or column by the field's distinct values, arranged according to the chart variant:

- **Clustered** - values appear as separate bars side by side within each category.
- **Stacked** - values appear as stacked segments within one bar.
- **100% Stacked** - segments are proportional, each bar normalised to 100%.

**Multiple measures, no Legend field.** Each measure becomes its own series, defined by the measure name.

**Multiple measures with a Legend field.** Measures form the primary (outer) grouping and legend values the secondary (inner) grouping. Colours stay consistent per legend value across every measure group. For example, plot Net Sales and Gross Sales by region with Segment in the Legend slot - X-Axis: Region, Y-Axis: Net Sales and Gross Sales, Legend: Segment. Each region then carries six values - Net Sales and Gross Sales, each split across Enterprise, Mid-Market, and SMB - arranged according to the chart variant:

- **Clustered** - six bars per region, grouped by measure first (the three Net Sales bars, then the three Gross Sales bars).
- **Stacked** - two bars per region (Net Sales, Gross Sales), each split into Enterprise, Mid-Market, and SMB segments.
- **100% Stacked** - as Stacked, normalised to 100%.

The example below plots Net Sales and Gross Sales by region with **Segment** assigned to the Legend slot, so each measure splits into one coloured series per segment - Enterprise, Mid-Market, and SMB - with colours consistent across both measures. Open the Setup panel to change or clear the Legend field, or change the chart type to another bar or column variant to see how the arrangement differs.

#### Legend on Bar and Column Charts

```ts
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component.ts';

const app = bootstrapApplication(AppComponent, {
    providers: [provideHttpClient()],
});
```

[Live example: Legend on Bar and Column Charts](https://www.ag-grid.com/studio/archive/3.0.0/examples/building-widgets/legend-bar-column/angular/)

### Scatter and Bubble Charts

The Legend field splits plotted points into one coloured series per distinct value, with consistent colours and tooltips reflecting the hovered point's legend value. Bubble charts behave identically: the Size measure still drives bubble area within each series.

The example below plots average quantity against average discount as a bubble chart, with bubble size driven by net sales and **Category** assigned to the Legend slot, so each point belongs to one coloured series per product category.

#### Legend on Scatter and Bubble Charts

```ts
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component.ts';

const app = bootstrapApplication(AppComponent, {
    providers: [provideHttpClient()],
});
```

[Live example: Legend on Scatter and Bubble Charts](https://www.ag-grid.com/studio/archive/3.0.0/examples/building-widgets/legend-scatter-bubble/angular/)

### Line and Area Charts

**Single measure.** The Legend field splits the measure into one line or area per distinct value, each with its own colour and legend entry. This is the way to plot one measure across several categories - for example, revenue over time with one line per country.

**Multiple measures with a Legend field.** Each measure is split by every legend value, and the series are labelled with both parts, such as `Net Sales · Enterprise`. Colours stay consistent per series, and tooltips show the hovered series' legend value.

The Area variants stack the split series: **Stacked** areas add up to the total, and **100% Stacked** areas are normalised so each period fills the plot.

### Limiting the Number of Series

A Legend field with many distinct values would produce one series per value and a legend too large to read. Charts guard against this automatically, keeping only the most significant series. This engages only when the series count would exceed 50; below that, every series renders as normal.

Legend values are ranked by measure value, largest first, and the chart keeps the largest 50 series and leaves the rest out altogether. With several measures, every legend value produces one series per measure, so the measures share the limit: two measures keep the 25 largest legend values each, ranked by the first measure, and every measure shows the same values. Whenever series have been left out, the chart says so in the browser console while development validations are enabled.

## Widget-Specific Options

Some Widget families have setup slots and options of their own, such as the Rows, Columns and Values slots on a Pivot Table or the Hierarchy Levels on a Treemap. These are described with the Widget in the [Widget Catalogue](https://www.ag-grid.com/studio/archive/3.0.0/angular/widget-catalogue/).


---
product: "AG Studio"
title: "Building Widgets"
description: "A Widget on the layout has its data and appearance configured in the Edit Panel."
framework: vue
version: "3.0.0"
related:
    - title: "Widget Basics"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/vue/widgets/"
    - title: "Widget Catalogue"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/vue/widget-catalogue/"
llms: "https://www.ag-grid.com/studio/archive/3.0.0/llms.txt"
---

# Building Widgets

A Widget on the layout has its data and appearance configured in the Edit Panel.

In [Edit Mode](https://www.ag-grid.com/studio/archive/3.0.0/vue/user-interface/#modes), clicking a Widget on the layout puts it into focus. When a Widget is focused, the [Edit Panel](https://www.ag-grid.com/studio/archive/3.0.0/vue/user-interface/#edit-panel) updates to show Widget configuration, split into two tabs:

- **Setup** - configures data inputs and interactivity.
- **Format** - controls how the Widget looks.

The example below shows a bar chart displaying Net Sales by Region. Clicking on the chart updates the Edit Panel to show the Setup and Format tabs for that Widget.

#### Edit Panel

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgStudio } from "ag-studio-vue3";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgPanelConfig,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";
import { getMainDemoData } from "./data.ts";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div style="display: flex; flex-direction: column; height: 100%">
      <ag-studio
        style="width: 100%; height: 100%;"
        class="my-studio-container"
        @api-ready="onApiReady"
        :initialState="initialState"
        :mode="mode"
        :panels="panels"
        :data="data"></ag-studio>
      </div>
        </div>
    `,
  components: {
    "ag-studio": AgStudio,
  },
  setup(props) {
    const studioApi = shallowRef<AgStudioApi | null>(null);
    const initialState = ref<AgReportState>({
      pages: [
        {
          id: "a",
          widgets: {
            "region-net-sales": {
              type: "bar-chart-grouped",
              dataMapping: {
                categoryKey: [{ id: "stores.region" }],
                valueKey: [{ id: "net_sales" }],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Net Sales by Region",
                },
              },
            },
          },
          widgetLayout: {
            "region-net-sales": { xTrack: 0, yTrack: 0, xSpan: 24, ySpan: 32 },
          },
        },
      ],
      selectedPageId: "a",
    });
    const mode = ref<AgStudioMode>("edit");
    const panels = ref<AgPanelConfig>({
      edit: {
        right: ["edit"],
      },
    });
    const data = ref<AgDataSourcesDefinition | AgDataEngine>(
      getMainDemoData("https://www.ag-grid.com/studio/archive/3.0.0/example-assets"),
    );

    const onApiReady = (params: AgStudioApiReadyEvent) => {
      studioApi.value = params.api;
    };

    return {
      studioApi,
      initialState,
      mode,
      panels,
      data,
      onApiReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Edit Panel](https://www.ag-grid.com/studio/archive/3.0.0/examples/building-widgets/edit-panel-setup/vue3/)

## Widget Setup

Data can be dragged and dropped into an empty Widget or the Setup data section. The UI guides visually to the appropriate drop targets. If an item cannot be used in a slot, AG Studio prevents the drop and guides to a valid slot. This might be because no relationship between data is defined or Widget data requirements are not met.

Where possible, items can be reordered within a slot by dragging them into the required order, which determines the order of Fields being displayed. For detailed information on managing data fields, see [Data Setup](https://www.ag-grid.com/studio/archive/3.0.0/vue/data-setup/).

To remove an item, its remove action can be used from the data menu accessible in the data pill. Aggregation and sorting options are also in the same menu. Read more on [Aggregation and Sorting](https://www.ag-grid.com/studio/archive/3.0.0/vue/using-data/#aggregation).

Widgets can be changed to a different type via the Setup Panel dropdown. AG Studio will preserve field configurations during Widget type switching where possible. Where the new input requirement needs less data, additional fields will be dropped into Tooltip.

## Widget Formatting

Format settings vary by Widget type. Common settings include the Widget title and description, number formatting, labels and legends, and display options.

Additional customisation is supported on interactivity features such as crosshair, navigator, and zoom. The options available for customisation depend on the application preset and will vary depending on what is permitted.

## Reset to Default

When an Edit Panel setting differs from the default value, a reset to default button will appear next to the section name. Clicking this will reset all settings within that section to their default values.

Default values are different from saved state. If your application has loaded a saved state, the values will reset to the Studio default values rather than the saved state. The default values can be configured by your developer.

## Working with Date & Time

There are two ways to put dates on a Widget's axis, and they differ in the span of time the axis covers:

- **Drag a date field** - the axis covers the range of dates present in that field's data.
- **Drag a calendar** - the axis covers the date range defined for the calendar, regardless of which dates appear in the data.

In both cases the axis still narrows to match any filters applied to the Widget.

### Using a Date Field

Drop a date field onto a chart or table and the axis spans the dates found in that field. It groups by a default period - day for a date field, minute for a field that also carries a time of day.

To change the period, select the Widget to open the Setup panel on the right, then open the date field's menu from its pill in the data section and pick another period - year, quarter, month, week, or day. The periods on offer are configured by the developer. The pill shows the field name and the period it's using, for example Order Date · Month, so you can always see how dates are grouped. Changing the period re-groups the same field in place; you don't need to remove it and drag a different one.

In the example below, the Order Date field is on the axis and grouped by year. Select the chart, open the field's menu from its pill, and switch the period to see the chart re-group.

#### Grouping Dates on an Axis

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgStudio } from "ag-studio-vue3";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";
import { getData } from "./data.ts";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div style="display: flex; flex-direction: column; height: 100%">
      <ag-studio
        style="width: 100%; height: 100%;"
        class="my-studio-container"
        @api-ready="onApiReady"
        :initialState="initialState"
        :data="data"
        :mode="mode"></ag-studio>
      </div>
        </div>
    `,
  components: {
    "ag-studio": AgStudio,
  },
  setup(props) {
    const studioApi = shallowRef<AgStudioApi | null>(null);
    const initialState = ref<AgReportState>({
      selectedPageId: "by-year",
      pages: [
        {
          id: "by-year",
          selection: { type: "widget", id: "year-chart" },
          widgets: {
            "year-chart": {
              type: "bar-chart-grouped",
              dataMapping: {
                categoryKey: [{ id: "sales.order_date::year" }],
                valueKey: [{ id: "sales.amount", aggregation: "sum" }],
                tooltipKey: [],
              },
              format: { title: { enabled: true, text: "Revenue by Year" } },
            },
            "year-grid": {
              type: "grid",
              dataMapping: {
                cols: [
                  { id: "sales.order_date::year" },
                  { id: "sales.amount", aggregation: "sum" },
                  { id: "sales.amount", aggregation: "count" },
                  { id: "sales.amount", aggregation: "avg" },
                ],
              },
              sort: [
                { field: { id: "sales.order_date::year" }, direction: "asc" },
              ],
            },
          },
          widgetLayout: {
            "year-chart": { xTrack: 0, yTrack: 0, xSpan: 24, ySpan: 20 },
            "year-grid": { xTrack: 0, yTrack: 20, xSpan: 24, ySpan: 10 },
          },
        },
      ],
      panels: {
        filters: {
          collapsed: true,
        },
        data: {
          collapsed: true,
        },
      },
    });
    const data = ref<AgDataSourcesDefinition | AgDataEngine>(getData());
    const mode = ref<AgStudioMode>("edit");

    const onApiReady = (params: AgStudioApiReadyEvent) => {
      studioApi.value = params.api;
    };

    return {
      studioApi,
      initialState,
      data,
      mode,
      onApiReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Grouping Dates on an Axis](https://www.ag-grid.com/studio/archive/3.0.0/examples/building-widgets/time-axis-example/vue3/)

### Using a Calendar

A [calendar](https://www.ag-grid.com/studio/archive/3.0.0/vue/calendars/) is a named date range defined in the dashboard's data, with a fixed start and end. Its time periods (Year, Quarter, Month, and so on) appear in the Data Panel as their own group, named after the calendar.

Dragging a calendar period works just like dragging a date field - you place it on an axis and change its period from the pill the same way. Two things differ: the periods on offer come from the calendar, and the axis spans the calendar's whole range rather than the dates in your data.

Drag a calendar period such as Month onto a Widget and a chart's timeline stays continuous: periods with no data show as gaps instead of being skipped, which keeps trends honest. The axis still responds to filters, narrowing to the filtered range.

The example below produces the same chart as above, but the axis comes from dragging in a calendar period rather than the date field. Select the chart and open the field's menu to switch the period.

#### Grouping Dates with a Calendar

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgStudio } from "ag-studio-vue3";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";
import { getData } from "./data.ts";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div style="display: flex; flex-direction: column; height: 100%">
      <ag-studio
        style="width: 100%; height: 100%;"
        class="my-studio-container"
        @api-ready="onApiReady"
        :initialState="initialState"
        :data="data"
        :mode="mode"></ag-studio>
      </div>
        </div>
    `,
  components: {
    "ag-studio": AgStudio,
  },
  setup(props) {
    const studioApi = shallowRef<AgStudioApi | null>(null);
    const initialState = ref<AgReportState>({
      selectedPageId: "by-year",
      pages: [
        {
          id: "by-year",
          selection: { type: "widget", id: "year-chart" },
          widgets: {
            "year-chart": {
              type: "bar-chart-grouped",
              dataMapping: {
                categoryKey: [{ id: "calendar::year" }],
                valueKey: [{ id: "sales.amount", aggregation: "sum" }],
                tooltipKey: [],
              },
              format: { title: { enabled: true, text: "Revenue by Year" } },
            },
            "year-grid": {
              type: "grid",
              dataMapping: {
                cols: [
                  { id: "calendar::year" },
                  { id: "sales.amount", aggregation: "sum" },
                  { id: "sales.amount", aggregation: "count" },
                  { id: "sales.amount", aggregation: "avg" },
                ],
              },
              sort: [{ field: { id: "calendar::year" }, direction: "asc" }],
            },
          },
          widgetLayout: {
            "year-chart": { xTrack: 0, yTrack: 0, xSpan: 24, ySpan: 20 },
            "year-grid": { xTrack: 0, yTrack: 20, xSpan: 24, ySpan: 10 },
          },
        },
      ],
      panels: {
        filters: {
          collapsed: true,
        },
        data: {
          collapsed: true,
        },
      },
    });
    const data = ref<AgDataSourcesDefinition | AgDataEngine>(getData());
    const mode = ref<AgStudioMode>("edit");

    const onApiReady = (params: AgStudioApiReadyEvent) => {
      studioApi.value = params.api;
    };

    return {
      studioApi,
      initialState,
      data,
      mode,
      onApiReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Grouping Dates with a Calendar](https://www.ag-grid.com/studio/archive/3.0.0/examples/building-widgets/time-axis-calendar-example/vue3/)

## Group By Legend

The Legend field splits a single chart into multiple coloured series by a categorical dimension - for example, sales broken down by region. It is available on Bar, Column, Line, Area, Scatter, and Bubble charts.

Charts that support a legend expose a **Legend** slot in the Setup panel. Assign a categorical field to break the chart down by that field's distinct values: each value gets its own colour, and the legend updates automatically. Removing the field reverts to a single series.

### Bar and Column Charts

How a Legend field segments each bar or column depends on how many measures are present.

**Single measure.** The Legend field splits each bar or column by the field's distinct values, arranged according to the chart variant:

- **Clustered** - values appear as separate bars side by side within each category.
- **Stacked** - values appear as stacked segments within one bar.
- **100% Stacked** - segments are proportional, each bar normalised to 100%.

**Multiple measures, no Legend field.** Each measure becomes its own series, defined by the measure name.

**Multiple measures with a Legend field.** Measures form the primary (outer) grouping and legend values the secondary (inner) grouping. Colours stay consistent per legend value across every measure group. For example, plot Net Sales and Gross Sales by region with Segment in the Legend slot - X-Axis: Region, Y-Axis: Net Sales and Gross Sales, Legend: Segment. Each region then carries six values - Net Sales and Gross Sales, each split across Enterprise, Mid-Market, and SMB - arranged according to the chart variant:

- **Clustered** - six bars per region, grouped by measure first (the three Net Sales bars, then the three Gross Sales bars).
- **Stacked** - two bars per region (Net Sales, Gross Sales), each split into Enterprise, Mid-Market, and SMB segments.
- **100% Stacked** - as Stacked, normalised to 100%.

The example below plots Net Sales and Gross Sales by region with **Segment** assigned to the Legend slot, so each measure splits into one coloured series per segment - Enterprise, Mid-Market, and SMB - with colours consistent across both measures. Open the Setup panel to change or clear the Legend field, or change the chart type to another bar or column variant to see how the arrangement differs.

#### Legend on Bar and Column Charts

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgStudio } from "ag-studio-vue3";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgPanelConfig,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";
import { getMainDemoData } from "./data.ts";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div style="display: flex; flex-direction: column; height: 100%">
      <ag-studio
        style="width: 100%; height: 100%;"
        class="my-studio-container"
        @api-ready="onApiReady"
        :initialState="initialState"
        :mode="mode"
        :panels="panels"
        :data="data"></ag-studio>
      </div>
        </div>
    `,
  components: {
    "ag-studio": AgStudio,
  },
  setup(props) {
    const studioApi = shallowRef<AgStudioApi | null>(null);
    const initialState = ref<AgReportState>({
      pages: [
        {
          id: "a",
          widgets: {
            "region-net-sales": {
              type: "bar-chart-stacked",
              dataMapping: {
                categoryKey: [{ id: "stores.region" }],
                valueKey: [{ id: "net_sales" }, { id: "gross_sales" }],
                legendKey: [{ id: "customers.segment" }],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Net Sales and Gross Sales by Region and Segment",
                },
                style: {
                  theme: {
                    common: {
                      legend: {
                        enabled: true,
                      },
                    },
                  },
                },
              },
            },
          },
          widgetLayout: {
            "region-net-sales": { xTrack: 0, yTrack: 0, xSpan: 24, ySpan: 32 },
          },
          selection: { type: "widget", id: "region-net-sales" },
        },
      ],
      selectedPageId: "a",
    });
    const mode = ref<AgStudioMode>("edit");
    const panels = ref<AgPanelConfig>({
      edit: {
        right: ["edit"],
      },
    });
    const data = ref<AgDataSourcesDefinition | AgDataEngine>(
      getMainDemoData("https://www.ag-grid.com/studio/archive/3.0.0/example-assets"),
    );

    const onApiReady = (params: AgStudioApiReadyEvent) => {
      studioApi.value = params.api;
    };

    return {
      studioApi,
      initialState,
      mode,
      panels,
      data,
      onApiReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Legend on Bar and Column Charts](https://www.ag-grid.com/studio/archive/3.0.0/examples/building-widgets/legend-bar-column/vue3/)

### Scatter and Bubble Charts

The Legend field splits plotted points into one coloured series per distinct value, with consistent colours and tooltips reflecting the hovered point's legend value. Bubble charts behave identically: the Size measure still drives bubble area within each series.

The example below plots average quantity against average discount as a bubble chart, with bubble size driven by net sales and **Category** assigned to the Legend slot, so each point belongs to one coloured series per product category.

#### Legend on Scatter and Bubble Charts

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgStudio } from "ag-studio-vue3";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgPanelConfig,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";
import { getMainDemoData } from "./data.ts";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div style="display: flex; flex-direction: column; height: 100%">
      <ag-studio
        style="width: 100%; height: 100%;"
        class="my-studio-container"
        @api-ready="onApiReady"
        :initialState="initialState"
        :mode="mode"
        :panels="panels"
        :data="data"></ag-studio>
      </div>
        </div>
    `,
  components: {
    "ag-studio": AgStudio,
  },
  setup(props) {
    const studioApi = shallowRef<AgStudioApi | null>(null);
    const initialState = ref<AgReportState>({
      pages: [
        {
          id: "a",
          widgets: {
            "qty-vs-discount": {
              type: "bubble-chart",
              dataMapping: {
                groupByKey: [{ id: "products.brand" }],
                categoryKey: [
                  { id: "order_items.quantity", aggregation: "avg" },
                ],
                valueKey: [
                  { id: "order_items.discount_pct", aggregation: "avg" },
                ],
                sizeKey: [{ id: "line_net", aggregation: "sum" }],
                legendKey: [{ id: "products.subcategory" }],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Quantity vs Discount (size by Net Sales)",
                },
                style: {
                  theme: {
                    common: { legend: { enabled: true, position: "bottom" } },
                  },
                },
              },
            },
          },
          widgetLayout: {
            "qty-vs-discount": { xTrack: 0, yTrack: 0, xSpan: 24, ySpan: 38 },
          },
          selection: { type: "widget", id: "qty-vs-discount" },
        },
      ],
      selectedPageId: "a",
    });
    const mode = ref<AgStudioMode>("edit");
    const panels = ref<AgPanelConfig>({
      edit: {
        right: ["edit"],
      },
    });
    const data = ref<AgDataSourcesDefinition | AgDataEngine>(
      getMainDemoData("https://www.ag-grid.com/studio/archive/3.0.0/example-assets"),
    );

    const onApiReady = (params: AgStudioApiReadyEvent) => {
      studioApi.value = params.api;
    };

    return {
      studioApi,
      initialState,
      mode,
      panels,
      data,
      onApiReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Legend on Scatter and Bubble Charts](https://www.ag-grid.com/studio/archive/3.0.0/examples/building-widgets/legend-scatter-bubble/vue3/)

### Line and Area Charts

**Single measure.** The Legend field splits the measure into one line or area per distinct value, each with its own colour and legend entry. This is the way to plot one measure across several categories - for example, revenue over time with one line per country.

**Multiple measures with a Legend field.** Each measure is split by every legend value, and the series are labelled with both parts, such as `Net Sales · Enterprise`. Colours stay consistent per series, and tooltips show the hovered series' legend value.

The Area variants stack the split series: **Stacked** areas add up to the total, and **100% Stacked** areas are normalised so each period fills the plot.

### Limiting the Number of Series

A Legend field with many distinct values would produce one series per value and a legend too large to read. Charts guard against this automatically, keeping only the most significant series. This engages only when the series count would exceed 50; below that, every series renders as normal.

Legend values are ranked by measure value, largest first, and the chart keeps the largest 50 series and leaves the rest out altogether. With several measures, every legend value produces one series per measure, so the measures share the limit: two measures keep the 25 largest legend values each, ranked by the first measure, and every measure shows the same values. Whenever series have been left out, the chart says so in the browser console while development validations are enabled.

## Widget-Specific Options

Some Widget families have setup slots and options of their own, such as the Rows, Columns and Values slots on a Pivot Table or the Hierarchy Levels on a Treemap. These are described with the Widget in the [Widget Catalogue](https://www.ag-grid.com/studio/archive/3.0.0/vue/widget-catalogue/).
